#ifndef _XWINDOW_H
#define _XWINDOW_H

/* Currently if no resolution is used it sets RES1024 */
#ifndef RES800
  #ifndef RESVAR
    #ifndef RES1024
	   #define RES1024
    #endif 
  #endif
#endif

#ifdef RES1024
/* This is to be used in a 1024x768 resolution */
#define WIN_WID 832
#define WIN_HGT 750
#define PIXMAP_SIZE (48)
/* general definitions */
#define SCROLL_W (16)
#define GEST_SIZE (48)
#define GEST_SMALL (16)
#define FRAME_SHADOW (3)


#define COLUMN_SIZE (8)
#define COLUMN_X (476)
#define COLUMN_Y (33)
#define GEST_SPACE (50)
#define X_BETWEEN_COLS (20)

/* Definitions previously in xbutton.c */
#define BBOX_X (32)
#define BBOX_Y (610)
#define BBOX_W (2)
#define BBOX_H (1)

#define BUTTON_W (150)
#define BUTTON_H (32)
#define BUTTON_CORNER (3)
#define BUTTON_SPACE (4)

/* Definitions previously in xquery.c */
#define QUERY_X  (32)
#define QUERY_Y  (642)
#define QUERY_W  (736)
#define QUERY_H  (100)
#define QUERY_AW  (450)

/* Definitions previously in xgest.c */
#define QUERY_LEADING (8)
#define QMENU_LEADING (4)
#define QMENU_BORDER (4)
#define GEST_SPACE (50)
#define X_BETWEEN_COLS (20)

/* Definitions previously in xtext.c */

#define TEXT_WID (400) 
#define TEXT_HGT (550)
#define TEXT_X (32)
#define TEXT_Y (32)

#define MAXLINESIZE (512) /* maximum number of chars that could possibly fit
			     in a line. If the player uses bits1, this will
			     probably crash. Tough. */

/* Definitions previously in xtalk.c */
#define TALK_X (380)
#define TALK_Y (610)
#define TALK_W (448)
#define TALK_LEADING (8)


/* Definitios previously in xloop.c */
#define STATS_X (476)
#define STATS_Y (449)
#define STATS_W (324)
#define STATS_H (150)
#define STATS_HP (244)



#endif

#ifdef RES800
/* This is for 800x600 */

/* Definitions previously in main.c */
#define WIN_WID 800
#define WIN_HGT 600
#define PIXMAP_SIZE (48)

/* Definitions previousy in xgest.c */
/* Define the size for the gesture history
   list. Was defined with 8 gestures */
/* Maybe we could do adjust COLUMN_SIZE 
   a bit better so it auto adjusts 
   based on the resolution (WIN_WID).
   Perhaps based on size of pixmaps 48x48?*/
#define COLUMN_SIZE (5)
#define COLUMN_X (460)
#define COLUMN_Y (33)
#define GEST_SPACE (50)
#define X_BETWEEN_COLS (20)
/* general definitions */
#define SCROLL_W (16)
#define GEST_SIZE (48)
#define GEST_SMALL (16)
#define FRAME_SHADOW (3)


/* Definitions previously in xbutton.c */
/* Defines the position and size of buttons */
#define BBOX_X (32)
#define BBOX_Y (400)
#define BBOX_W (2)
#define BBOX_H (1)

#define BUTTON_W (150)
#define BUTTON_H (32)
#define BUTTON_CORNER (3)
#define BUTTON_SPACE (4)


/* Definitions previously in xtext.c */

#define TEXT_WID (400) 
#define TEXT_HGT (350)
#define TEXT_X (32)
#define TEXT_Y (32)

#define MAXLINESIZE (512) /* maximum number of chars that could possibly fit
			     in a line. If the player uses bits1, this will
			     probably crash. Tough. */

/* Definitions previously in xquery.c */
#define QUERY_X  (32)
#define QUERY_Y  (450)
#define QUERY_W  (736)
#define QUERY_H  (100)
#define QUERY_AW  (450)

#define QUERY_LEADING (8)
#define QMENU_LEADING (4)
#define QMENU_BORDER (4)

#define GEST_SPACE (50)

/* Definitions previously in xtalk.c */
#define TALK_X (335)
#define TALK_Y (400)
#define TALK_W (430)
#define TALK_LEADING (8)


/* Definitios previously in xloop.c */
#define STATS_X (475)
#define STATS_Y (300)
#define STATS_W (300)
#define STATS_H (85)
#define STATS_HP (244)


#endif

#ifdef RESSMALL
/* Taken from patched spellcast found at */
/* This is to be used in a small resolution */
#define WIN_WID 832
#define WIN_HGT 575
#define PIXMAP_SIZE (48)
/* general definitions */
#define SCROLL_W (16)
#define GEST_SIZE (48)
#define GEST_SMALL (16)
#define FRAME_SHADOW (3)

/* Definitions previously in xgest.c */
#define COLUMN_SIZE (8)
#define COLUMN_X (426)
#define COLUMN_Y (18)
#define GEST_SPACE (50)
#define X_BETWEEN_COLS (10)



/* Definitions previously in xbutton.c */
#define BBOX_X (32)
#define BBOX_Y (426)
#define BBOX_W (2)
#define BBOX_H (1)

#define BUTTON_W (150)
#define BUTTON_H (28)
#define BUTTON_CORNER (3)
#define BUTTON_SPACE (4)

/* Definitions previously in xquery.c */
#define QUERY_X  (32)
#define QUERY_Y  (465)
#define QUERY_W  (736)
#define QUERY_H  (100)
#define QUERY_AW  (450)

#define QUERY_LEADING (8)
#define QMENU_LEADING (4)
#define QMENU_BORDER (4)

#define GEST_SPACE (50)

/* Definitions previously in xtext.c */

#define TEXT_WID (400) 
#define TEXT_HGT (332)
#define TEXT_X (18)
#define TEXT_Y (5)

#define MAXLINESIZE (512) /* maximum number of chars that could possibly fit
			     in a line. If the player uses bits1, this will
			     probably crash. Tough. */

/* Definitions previously in xtalk.c */
#define TALK_X (380)
#define TALK_Y (425)
#define TALK_W (448)
#define TALK_LEADING (8)


/* Definitios previously in xloop.c */
#define STATS_X (18)
#define STATS_Y (343)
#define STATS_W (324)
#define STATS_H (74)
#define STATS_HP (244)



#endif


#ifdef RESVAR
/* This is for other resolutions */
/* TODO: this must be intelligently done so that we can
   define WIN_WID and WIN_HGT and we get an acceptable screen */

/* Definitions previously in main.c */
#define WIN_WID 800
#define WIN_HGT 600
#define PIXMAP_SIZE (48)
/* general definitions */
#define SCROLL_W (16)
#define GEST_SIZE (48)
#define GEST_SMALL (16)
#define FRAME_SHADOW (3)


/* Definitions previousy in xgest.c */
/* Define the size for the gesture history
   list. Was defined with 8 gestures */
/* Maybe we could do adjust COLUMN_SIZE 
   a bit better so it auto adjusts 
   based on the resolution (WIN_WID).
   Perhaps based on size of pixmaps 48x48?*/
#define COLUMN_SIZE (8)
#define COLUMN_X (60+WIN_WID/2)
#define COLUMN_Y (33)
#define GEST_SPACE (50)

/* Definitions previouls in xbutton.c */
/* Defines the position and size of buttons */
#define BBOX_X (32)
#define BBOX_Y (WIN_HGT)
#define BBOX_W (2)
#define BBOX_H (1)

#define BUTTON_W (150)
#define BUTTON_H (32)
#define BUTTON_CORNER (3)
#define BUTTON_SPACE (4)


/* Definitions previously in xtext.c */

#define TEXT_WID (WIN_WID/2) 
#define TEXT_HGT (WIN_HGT*5/6)
#define TEXT_X (32)
#define TEXT_Y (32)

#define MAXLINESIZE (512) /* maximum number of chars that could possibly fit
			     in a line. If the player uses bits1, this will
			     probably crash. Tough. */

/* Definitions previously in xquery.c */
#define QUERY_X  (32)
#define QUERY_Y  (WIN_HGT+10)
#define QUERY_W  (736)
#define QUERY_H  (100)
#define QUERY_AW  (450)

#define QUERY_LEADING (8)
#define QMENU_LEADING (4)
#define QMENU_BORDER (4)
#define GEST_SPACE (50)
#define X_BETWEEN_COLS (20)

/* Definitions previously in xtalk.c */
#define TALK_X (WIN_WID/2)
#define TALK_Y (WIN_HGT*5/6+10)
#define TALK_W (448)
#define TALK_LEADING (8)


/* Definitios previously in xloop.c */
#define STATS_X (476)
#define STATS_Y (449)
#define STATS_W (324)
#define STATS_H (104)
#define STATS_HP (244)


#endif

#endif /* of ifndef XWINDOW_H */
